Subject: Re: [Bitcoin-development] P2P feature discovery (was Re: BIP 33 - Stratized Nodes)

From: "Luke-Jr" <[email-masked]>
Date: Wed, 16 May 2012 18:29:41 +0000

On Wednesday, May 16, 2012 6:18:27 PM Jeff Garzik wrote:
> Instead of further overloading service bits in the version message, or
> altering the version message, let us instead make feature discovery an
> easy, flexible, extensible process.
> 
> We can add new commands without impacting older nodes, so let's create
> a new command "get-features" (or pick your name) that returns a list
> of key/value pairs.  The key is a string, the value type is determined
> by the key.

That assumes you already have a connection to the peer in question.
As I understand it, the service bits are propagated as part of the address, 
so you can see at a glance which nodes you want to connect to for some 
special service. Passing a huge list along might be unwieldy (though it 
makes sense for protocol changes that don't add new services).